﻿using System.Linq;
using Telerik.OpenAccess.Metadata;
using Telerik.OpenAccess.Metadata.Relational;

namespace TestApplication
{
    public partial class DataModel
    {
        static DataModel()
        {
            DataModel.SetupTimeSpanToFloatConverter("CustomClass", "OrderDate");
        }

        public static void SetupTimeSpanToFloatConverter(string tableName, string columnName)
        {
            MetadataContainer container = metadataSource.GetModel();
            MetaTable metaTable = container.Tables.FirstOrDefault(x => x.Name.Equals(tableName));
            if (metaTable != null)
            {
                MetaColumn metaColumn = metaTable.Columns.FirstOrDefault(x => x.Name.Equals(columnName));
                if (metaColumn != null)
                {
                    metaColumn.Converter = typeof(TimeSpanToFloatConverter).AssemblyQualifiedName;
                }
            }
        }
    }
}
